import _extends from "@babel/runtime/helpers/esm/extends";
import * as React from 'react';
import * as R from 'ramda';
import PropTypes from 'prop-types';
import Portal from '../Portal';
import Transition from '../Transition';
import emptyFunction from '../utils/emptyFunction';
import { BackdropContainer, Container } from './Components';

var Dialog = function Dialog(_ref) {
  var show = _ref.show,
      children = _ref.children,
      onOutsideClick = _ref.onOutsideClick,
      backdropTransition = _ref.backdropTransition,
      containerTransition = _ref.containerTransition;
  return show && React.createElement(React.Fragment, null, React.createElement(Portal, null, React.createElement(Transition, _extends({
    component: false
  }, backdropTransition), React.createElement(BackdropContainer, {
    onClick: onOutsideClick
  })), React.createElement(Container, null, React.createElement(Transition, _extends({
    component: false
  }, containerTransition), React.cloneElement(children, {
    style: _extends({
      pointerEvents: 'all'
    }, R.path(['props', 'style'], children))
  })))));
};

process.env.NODE_ENV !== "production" ? Dialog.propTypes = {
  show: PropTypes.bool,
  children: PropTypes.node.isRequired,
  onOutsideClick: PropTypes.func,
  backdropTransition: PropTypes.shape({
    style: PropTypes.object,
    animation: PropTypes.object
  }),
  containerTransition: PropTypes.shape({
    style: PropTypes.object,
    animation: PropTypes.object
  })
} : void 0;
Dialog.defaultProps = {
  show: false,
  onOutsideClick: emptyFunction,
  backdropTransition: {
    style: {
      opacity: 0.3
    },
    animation: {
      ease: 'easeOutCubic',
      duration: 200,
      delay: 0,
      opacity: 1
    }
  },
  containerTransition: {
    style: {
      transform: 'translateY(-20px)'
    },
    animation: {
      ease: 'easeOutQuart',
      duration: 200,
      delay: 0,
      translateY: 0
    }
  }
};
export default Dialog;